
var SUCCESS = 'success';
var ERROR = 'error';

var serverErrorMessage = 'Oops, something wrong :(';

$(document).ready(function() {
    $('#treeDataTable').DataTable( {
        "ajax": {
            "url": "/gsmm/list",
            "dataType": "json"
        },
         "columns": [
                    { "data": "gsbh" },
                    { "data": "cname" },
                    { "data": "treelevel" },
                    { "data": "treeheight","defaultContent": ""},
                    { "data": "treeage","defaultContent": "" },
                    { "data": "treechest" ,"defaultContent": ""},
                    { "data": "treewidth" ,"defaultContent": ""},
                    { "data": "treeprotect","defaultContent": ""},
                    { data: "id" ,
                     "render": function ( data) {
                                  return '<i id=" ' + data +' " class="edit-button glyphicon glyphicon-edit cursorPointer" ></i>';
                                }
                            },
                     { data: "id" ,
                        "render": function ( data ) {
                                   return '<i id=" ' + data +' " class="remove-button glyphicon glyphicon-trash cursorPointer"></i>';
                               }
                     }

                ]
    } );

    var tableTree = $('#treeDataTable').DataTable();

    // Delete employee event
    $("body").on( 'click', '.remove-button', function () {
        var currentRow = $(this);
        var treeId = $(this).attr('id').trim();
         bootbox.confirm("Are you sure?", function(result) {
            if(result) {
                    $.ajax({
                     url: "/gsmm/delete",
                     type: "GET",
                     data: {Id: treeId},
                     success:function(response){
                               if(response.status == SUCCESS) {
                                  showSuccessAlert(response.msg);
                                  tableTree.row(currentRow.parents('tr') ).remove().draw();
                              } else {
                                  showErrorAlert(serverErrorMessage);
                              }
                        },
                     error: function(){
                          showErrorAlert(serverErrorMessage);
                       }
                  });
            } else {
               //
              }
         });
    });


     // Edit employee event
     $("body").on( 'click', '.edit-button', function () {

         var treeId = $(this).attr('id').trim();
         $('#gsmmEditForm input[id=file]').val("")
            $('#gsmmEditModal').modal('show');
      $.ajax({
                 url: "/gsmmdic/0",
                 type: "GET",
                 "dataType": "json",
                  async:false,
                  success:function(response){
                        $('#gsmmEditForm select[name=ke]').empty();
                        $('#gsmmEditForm select[name=ke]').append($('<option>').text("-请选择").attr('value', 0));
                        $.each(response.data, function(i, obj) {
                               $('#gsmmEditForm select[name=ke]').append($('<option>').text(obj.ke).attr('value', obj.id));
                        });
                  },
                  error: function(){
                         showErrorAlert(serverErrorMessage);
                  }
         });
      $.ajax({
                 url: "/area/1114",
                 type: "GET",
                 "dataType": "json",
                 async:false,
                 success:function(response){
                          $('#gsmmEditForm select[name=city]').empty();
                          $('#gsmmEditForm select[name=city]').append($('<option>').text("-请选择").attr('value', 0));
                         $.each(response.data, function(i, obj) {
                                $('#gsmmEditForm select[name=city]').append($('<option>').text(obj.city).attr('value', obj.id));
                                });

                         },
                 error: function(){
                                showErrorAlert(serverErrorMessage);
                         }
                        });

      $.ajax({
                 url: "/gsmm/edit/"+treeId,
                 type: "GET",
                 data: {id: treeId},
                 success:function(response){

                       $.each(response.data, function(key, value){
                               if(key=="ke"||key=="treelevel"||key=="city")
                               {
                                 $('#gsmmEditForm select[name="'+key+'"]').val(value);
                                //alert($('#gsmmEditForm select[name="'+key+'"]').val());
                               }else if(key=="county"){
                                   var cityid=$('#gsmmEditForm select[name=city]').val()
                                    $.ajax({
                                                url: "/area/"+cityid,
                                                type: "GET",
                                                data: {pid: cityid},
                                                async:false,
                                               "dataType": "json",
                                                success:function(response){
                                                       $('#gsmmEditForm select[name=county]').empty();
                                                       $('#gsmmEditForm select[name=county]').append($('<option>').text("-请选择").attr('value', 0));
                                                       $.each(response.data, function(i, obj) {
                                                              $('#gsmmEditForm select[name=county]').append($('<option>').text(obj.district).attr('value', obj.id));
                                                               });
                                                        },
                                                  error: function(){
                                                               showErrorAlert(serverErrorMessage);
                                                        }
                                    });
                                    $('#gsmmEditForm select[name="'+key+'"]').val(value);
                               }else if(key=="shu"){
                                   var keId=$('#gsmmEditForm select[name=ke]').val()
                                   $.ajax({
                                            url: "/gsmmdic/"+keId,
                                            type: "GET",
                                            data: {id: keId},
                                           "dataType": "json",
                                            async:false,
                                            success:function(response){
                                                    $('#gsmmEditForm select[name=shu]').empty();
                                                    $('#gsmmEditForm select[name=shu]').append($('<option>').text("-请选择").attr('value', 0));
                                                    $.each(response.data, function(i, obj) {
                                                          $('#gsmmEditForm select[name=shu]').append($('<option>').text(obj.shu).attr('value', obj.id));
                                                           });
                                                    },
                                            error: function(){
                                                           showErrorAlert(serverErrorMessage);
                                                    }
                                   });
                                   $('#gsmmEditForm select[name="'+key+'"]').val(value);

                               } else if(key=="cname"){
                                    var shuId=$('#gsmmEditForm select[name=shu]').val()
                                    $.ajax({
                                             url: "/gsmmdic/"+shuId,
                                             type: "GET",
                                             data: {id: shuId},
                                             "dataType": "json",
                                              async:false,
                                              success:function(response){
                                                         $('#gsmmEditForm select[name=cname]').empty();
                                                         $('#gsmmEditForm select[name=cname]').append($('<option>').text("-请选择").attr('value', 0));
                                                         $.each(response.data, function(i, obj) {
                                                               $('#gsmmEditForm select[name=cname]').append($('<option>').text(obj.cname).attr('value', obj.id));
                                                                });
                                                         },
                                                   error: function(){
                                                                showErrorAlert(serverErrorMessage);
                                                         }
                                    });
                                    $('#gsmmEditForm select[name="'+key+'"]').val(value);
                               }else if(key=="treestatus"||key=="treeremark")
                               {
                                    $('#gsmmEditForm textarea[name="'+key+'"]').val(value);
                               }else{
                                     $('#gsmmEditForm input[name="'+key+'"]').val(value);
                                }

                             });
                             var picurl1=$('#gsmmEditForm input[name=treepicurl1]').val()
                             $("#gsmmEditForm img[id=treepic1]").attr("src",picurl1);
                             $("#treepic1").show();
                             var picurl2=$('#gsmmEditForm input[name=treepicurl2]').val()
                             $("#gsmmEditForm img[id=treepic2]").attr("src",picurl2);
                             $("#treepic2").show();

                      },
                 error: function(){
                             showErrorAlert(serverErrorMessage);
                     }
                });
          });




$('#gsmmModal').on('shown.bs.modal', function () {
  $('#gsmmForm').trigger("reset");
  $("#gsmmForm img[id=treepic1]").attr("src","");
  $("#gsmmForm img[id=treepic2]").attr("src","");
  $("#treepic1").hide();
  $("#treepic2").hide();
  $.ajax({
               url: "/gsmmdic/0",
               type: "GET",
               "dataType": "json",
               success:function(response){
                       $('#ke').empty();
                       $('#ke').append($('<option>').text("-请选择").attr('value', "0"));
                       $.each(response.data, function(i, obj) {
                             $('#ke').append($('<option>').text(obj.ke).attr('value', obj.id));
                              });

                       },
                 error: function(){
                              showErrorAlert(serverErrorMessage);
                       }
   });
  $.ajax({
           url: "/area/1114",
           type: "GET",
           "dataType": "json",
           success:function(response){
                   $('#city').empty();
                   $('#city').append($('<option>').text("-请选择").attr('value', 0));
                   $.each(response.data, function(i, obj) {
                         $('#city').append($('<option>').text(obj.city).attr('value', obj.id));
                          });

                   },
             error: function(){
                          showErrorAlert(serverErrorMessage);
                   }
                  });


});



//增加页面select联动事件
$('#city').change(function(){
  var cityid = $("#city").find("option:selected").val().toString();
  $.ajax({
             url: "/area/"+cityid,
             type: "GET",
             data: {pid: cityid},
            "dataType": "json",
             success:function(response){
                     $('#county').empty();
                     $('#county').append($('<option>').text("-请选择").attr('value', 0));
                     $.each(response.data, function(i, obj) {
                           $('#county').append($('<option>').text(obj.district).attr('value', obj.id));
                            });
                     },
               error: function(){
                            showErrorAlert(serverErrorMessage);
                     }
                    });
});

$('#ke').change(function(){
  var keId = $("#ke").find("option:selected").val().toString();
  $.ajax({
             url: "/gsmmdic/"+keId,
             type: "GET",
             data: {id: keId},
            "dataType": "json",
             success:function(response){
                     $('#shu').empty();
                     $('#shu').append($('<option>').text("-请选择").attr('value', 0));
                     $.each(response.data, function(i, obj) {
                           $('#shu').append($('<option>').text(obj.shu).attr('value', obj.id));
                            });
                     },
               error: function(){
                            showErrorAlert(serverErrorMessage);
                     }
                    });
});

$('#shu').change(function(){
  var shuId = $("#shu").find("option:selected").val().toString();
  $.ajax({
             url: "/gsmmdic/"+shuId,
             type: "GET",
             data: {id: shuId},
            "dataType": "json",
             success:function(response){
                     $('#cname').empty();
                     $('#cname').append($('<option>').text("-请选择").attr('value', 0));
                     $.each(response.data, function(i, obj) {
                           $('#cname').append($('<option>').text(obj.cname).attr('value', obj.id));
                            });
                     },
               error: function(){
                            showErrorAlert(serverErrorMessage);
                     }
                    });
});

$('#cname').change(function(){
  var Id = $("#cname").find("option:selected").val().toString();
  $.ajax({
             url: "/gsmmdic/lname/"+Id,
             type: "GET",
             data: {id: Id},
            "dataType": "json",
             success:function(response){
                   $('#lname').val(response.data.lname);
             },
             error: function(){
                            showErrorAlert(serverErrorMessage);
             }
     });
});


$('#picupload1').click(function(event){
      event.preventDefault();
      var imgVal = $('#gsmmForm input[name=file]').val();
      var suffixIndex=imgVal.lastIndexOf(".");
      var suffix=imgVal.substring(suffixIndex+1).toUpperCase();
      if(imgVal=='')
       {
           alert("图片为空，请选择后上传!");
           return false;
       }else if(suffix!="BMP"&&suffix!="JPG"&&suffix!="JPEG"&&suffix!="PNG"&&suffix!="GIF"){
            alert("请上传图片（格式BMP、JPG、JPEG、PNG、GIF等）!");
            return false;
       }else{
         var file = $('#file').get(0).files[0];
         var formData = new FormData();
         formData.append('file', file);
         $.ajax({
            url: '/qny/upload',
            data: formData,
            type: 'POST',
            contentType: false,
            processData: false,
            success: function (data) {
               alert("图片上传成功");
               $('#gsmmForm input[name=treepicurl1]').val(data);
               $("#gsmmForm img[id=treepic1]").attr("src",data);
               $("#treepic1").show();
           },
           error: function (jqXHR, textStatus, errorThrown) {
             alert(textStatus + ': ' + errorThrown);
           }
        });
      }
});
$('#picupload2').click(function(event){
      event.preventDefault();
      var imgVal = $('#gsmmForm input[name=file]').val();
      var suffixIndex=imgVal.lastIndexOf(".");
      var suffix=imgVal.substring(suffixIndex+1).toUpperCase();
      if(imgVal=='')
       {
           alert("图片为空，请选择后上传!");
           return false;
       }else if(suffix!="BMP"&&suffix!="JPG"&&suffix!="JPEG"&&suffix!="PNG"&&suffix!="GIF"){
            alert("请上传图片（格式BMP、JPG、JPEG、PNG、GIF等）!");
            return false;
       }else{
         var file = $('#file').get(0).files[0];
         var formData = new FormData();
         formData.append('file', file);
         $.ajax({
            url: '/qny/upload',
            data: formData,
            type: 'POST',
            contentType: false,
            processData: false,
            success: function (data) {
               alert("图片上传成功");
               $('#gsmmForm input[name=treepicurl2]').val(data);
               $("#gsmmForm img[id=treepic2]").attr("src",data);
               $("#treepic2").show();
           },
           error: function (jqXHR, textStatus, errorThrown) {
             alert(textStatus + ': ' + errorThrown);
           }
        });
      }
});
//更新页面select联动事件
$('#gsmmEditForm select[name=city]').change(function(){
  var cityid =$('#gsmmEditForm select[name=city]').find("option:selected").val().toString();
  $.ajax({
             url: "/area/"+cityid,
             type: "GET",
             data: {pid: cityid},
            "dataType": "json",
             success:function(response){
                     $('#gsmmEditForm select[name=county]').empty();
                     $('#gsmmEditForm select[name=county]').append($('<option>').text("-请选择").attr('value', 0));
                     $.each(response.data, function(i, obj) {
                           $('#gsmmEditForm select[name=county]').append($('<option>').text(obj.district).attr('value', obj.district));
                            });
                     },
               error: function(){
                            showErrorAlert(serverErrorMessage);
                     }
                    });
});

$('#gsmmEditForm select[name=ke]').change(function(){
  var keId = $('#gsmmEditForm select[name=ke]').find("option:selected").val().toString();
  $.ajax({
             url: "/gsmmdic/"+keId,
             type: "GET",
             data: {id: keId},
            "dataType": "json",
             success:function(response){
                     $('#gsmmEditForm select[name=shu]').empty();
                     $('#gsmmEditForm select[name=shu]').append($('<option>').text("-请选择").attr('value', 0));
                     $.each(response.data, function(i, obj) {
                           $('#gsmmEditForm select[name=shu]').append($('<option>').text(obj.shu).attr('value', obj.id));
                            });
                     },
               error: function(){
                            showErrorAlert(serverErrorMessage);
                     }
                    });
});

$('#gsmmEditForm select[name=shu]').change(function(){
  var shuId = $('#gsmmEditForm select[name=shu]').find("option:selected").val().toString();
  $.ajax({
             url: "/gsmmdic/"+shuId,
             type: "GET",
             data: {id: shuId},
            "dataType": "json",
             success:function(response){
                     $('#gsmmEditForm select[name=cname]').empty();
                     $('#gsmmEditForm select[name=cname]').append($('<option>').text("-请选择").attr('value', 0));
                     $.each(response.data, function(i, obj) {
                           $('#gsmmEditForm select[name=cname]').append($('<option>').text(obj.cname).attr('value', obj.id));
                            });
                     },
               error: function(){
                            showErrorAlert(serverErrorMessage);
                     }
                    });
});

$('#gsmmEditForm select[name=cname]').change(function(){
  var Id = $('#gsmmEditForm select[name=cname]').find("option:selected").val().toString();
  $.ajax({
             url: "/gsmmdic/lname/"+Id,
             type: "GET",
             data: {id: Id},
            "dataType": "json",
             success:function(response){

                   $('#gsmmEditForm input[name=lname]').val(response.data.lname);
                 },
             error: function(){
                   showErrorAlert(serverErrorMessage);
             }
        });
});

$('#gsmmEditForm input[id=picupload1]').click(function(event){
      event.preventDefault();
      var imgVal = $('#gsmmEditForm input[id=file]').val();
      var suffixIndex=imgVal.lastIndexOf(".");
      var suffix=imgVal.substring(suffixIndex+1).toUpperCase();
      if(imgVal=='')
       {
           alert("图片为空，请选择后上传!");
           return false;
       }else if(suffix!="BMP"&&suffix!="JPG"&&suffix!="JPEG"&&suffix!="PNG"&&suffix!="GIF"){
            alert("请上传图片（格式BMP、JPG、JPEG、PNG、GIF等）!");
            return false;
       }else{
         var file = $('#gsmmEditForm input[id=file]').get(0).files[0];
         var formData = new FormData();
         formData.append('file', file);
         $.ajax({
            url: '/qny/upload',
            data: formData,
            type: 'POST',
            contentType: false,
            processData: false,
            success: function (data) {
               alert("图片上传成功");
               $('#gsmmEditForm input[id=treepicurl1]').val(data);
               $("#gsmmEditForm img[id=treepic1]").attr("src",data);
               $("#treepic1").show();
           },
           error: function (jqXHR, textStatus, errorThrown) {
             alert(textStatus + ': ' + errorThrown);
           }
        });
      }
});
$('#gsmmEditForm input[id=picupload2]').click(function(event){
      event.preventDefault();
      var imgVal = $('#gsmmEditForm input[id=file]').val();
      var suffixIndex=imgVal.lastIndexOf(".");
      var suffix=imgVal.substring(suffixIndex+1).toUpperCase();
      if(imgVal=='')
       {
           alert("图片为空，请选择后上传!");
           return false;
       }else if(suffix!="BMP"&&suffix!="JPG"&&suffix!="JPEG"&&suffix!="PNG"&&suffix!="GIF"){
            alert("请上传图片（格式BMP、JPG、JPEG、PNG、GIF等）!");
            return false;
       }else{
         var file = $('#gsmmEditForm input[id=file]').get(0).files[0];
         var formData = new FormData();
         formData.append('file', file);
         $.ajax({
            url: '/qny/upload',
            data: formData,
            type: 'POST',
            contentType: false,
            processData: false,
            success: function (data) {
               alert("图片上传成功");
               $('#gsmmEditForm input[id=treepicurl2]').val(data);
               $("#gsmmEditForm img[id=treepic2]").attr("src",data);
               $("#treepic2").show();
           },
           error: function (jqXHR, textStatus, errorThrown) {
             alert(textStatus + ': ' + errorThrown);
           }
        });
      }
});
// Show success alert message
var showSuccessAlert = function (message) {
   	$.toaster({ priority : 'success', title : 'Success', message : message});
}

// Show error alert message
var showErrorAlert = function (message) {
    $.toaster({ priority : 'danger', title : 'Error', message : message});
}

// Convert form data in JSON format
$.fn.serializeObject = function() {
           var o = {};
           var a = this.serializeArray();
           $.each(a, function() {
                    if (o[this.name] !== undefined) {
                        if (!o[this.name].push) {
                            o[this.name] = [o[this.name]];
                        }
                        o[this.name].push(this.value || '');
                    } else {
                          if(this.name == 'id'||this.name=='city'||this.name=='county'||this.name=='ke'||this.name=='shu'||this.name=='cname'||this.name=='treelevel') {
                             o[this.name] = parseInt(this.value) || 0;
                          } else {
                         o[this.name] = this.value || '';
                         }
                    }
               });

            return JSON.stringify(o);
        };

// Handling form submission for create new employee
$('#gsmmForm').on('submit', function(e){
         var cityid = $("#city").find("option:selected").val();
         var countryid = $("#county").find("option:selected").val();
         var keid = $("#ke").find("option:selected").val();
         var shuid = $("#shu").find("option:selected").val();
         var cnameid = $("#cname").find("option:selected").val();
         var levelid = $("#treelevel").find("option:selected").val();
         if(cityid ==0||countryid==0||keid==0||shuid==0||cnameid==0||levelid==0){
              alert("城市、区县、科、属、中文名、等级下拉框均不能为空，请选择后再保存数据")
                         return false
         }else{
            var formData = $("#gsmmForm").serializeObject();
            var gsmmTable = $('#treeDataTable').dataTable();
            e.preventDefault();
            $.ajax({
                url: "/gsmm/create",
                type: "POST",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: formData,
                success:function(response){
                   if(response.status == "success") {
                         $('#gsmmModal').modal('hide');
                         var newGsmm = jQuery.parseJSON(formData);
                         newGsmm['id'] = response.data['id'];
                         gsmmTable.fnAddData([newGsmm]);
                         showSuccessAlert(response.msg);
                   } else {
                        $('#gsmmpModal').modal('hide');
                        showErrorAlert(response.msg);
                   }
                },
                error: function(){
                    $('#gsmmModal').modal('hide');
                    showErrorAlert(serverErrorMessage);
                }

            });
            return false;
         }
      });

// Handling form submission for update employee
$('#gsmmEditForm').on('submit', function(e){
         var cityid = $('#gsmmEditForm select[name=city]').find("option:selected").val();
         var countryid =$('#gsmmEditForm select[name=county]').find("option:selected").val();
         var keid =$('#gsmmEditForm select[name=ke]').find("option:selected").val();
         var shuid = $('#gsmmEditForm select[name=shu]').find("option:selected").val();
         var cnameid = $('#gsmmEditForm select[name=cname]').find("option:selected").val();
         var levelid = $('#gsmmEditForm select[name=treelevel]').find("option:selected").val();
         if(cityid ==0||countryid==0||keid==0||shuid==0||cnameid==0||levelid==0){
              alert("城市、区县、科、属、中文名、等级下拉框均不能为空，请选择后再保存数据")
                         return false
         }else{
               var formData = $("#gsmmEditForm").serializeObject();
                e.preventDefault();
                 $.ajax({
                      url: "/gsmm/update",
                      type: "POST",
                      contentType: "application/json; charset=utf-8",
                      dataType: "json",
                      data: formData,
                      success:function(response){
                         if(response.status == SUCCESS) {
                               $('#gsmmEditModal').modal('hide');
                               $('#treeDataTable').DataTable().ajax.reload();
                               showSuccessAlert(response.msg)
                         } else {
                            $('#gsmmEditModal').modal('hide');
                            showErrorAlert(response.msg);
                         }
                      },
                      error: function(){
                          $('#gsmmEditModal').modal('hide');
                          showErrorAlert(serverErrorMessage);
                      }

                  });
                  return false;
              }
          });

});